<?php

use Taxus\Privilege;

use function DI\{ autowire, add, create, get };

$dir = dirname(__DIR__, 2);

return [
    '%APPKEY%' => [
        'picea' => [
            'context' => "%ESCAPED_NAMESPACE%\\View",
            'asset' => [],
            'extensions' => [],
        ],

        'ulmus' => [
            'entities' => [ '%ESCAPED_NAMESPACE%\\Entity' => implode(DIRECTORY_SEPARATOR, [ $dir, 'src', 'Entity', '' ]) ],
        ],

        'routes' => [
            '%ESCAPED_NAMESPACE%\\Controller' => implode(DIRECTORY_SEPARATOR, [ $dir, 'src', 'Controller', '' ]),
        ],

        'events' => [
            '%ESCAPED_NAMESPACE%\\Controller' => implode(DIRECTORY_SEPARATOR, [ $dir, 'src', 'Controller', '' ]),
        ],

        'cronard' => [
            '%ESCAPED_NAMESPACE%\\Controller' => implode(DIRECTORY_SEPARATOR, [ $dir, 'src', 'Controller', '' ]),
        ],

        'cli' => [
            '%ESCAPED_NAMESPACE%\\Controller' => implode(DIRECTORY_SEPARATOR, [ $dir, 'src', 'Controller', '' ]),
        ],

        'taxus' => [
            'is_dev' => [ 'dev' => "Can manage almost everything in this application."],
            'is_admin' => [ 'admin' => "Can manage almost everything in this application."],
            'is_moderator' => [ 'moderator' => "Can moderate this application."],
            'is_user' => [ 'user' => "Is an authenticated user."],
            'is_anonymous' => [ 'anonymous' => "Is an anonymous (unauthenticated) user."],
        ]
    ],

    'app.middlewares' => \DI\add([
        Ulmus\User\Middleware\RememberMeMiddleware::class,
    ]),
];
