<?php

namespace Lean;

class Application
{
    public string $name;

    public /*string|array*/ $piceaContext;

    public array $piceaExtensions;

    public array $piceaAssets;

    public array $views;

    public array $routes;

    public array $cli;

    public array $cronard;

    public array $entities;

    public array $connectionAdapters;

    public array $events;

    public array $tellJson;

    public array $tellPhp;

    public array $taxus;

    public array $data = [];

    public function __construct(string $name) {
        $this->name = $name;
    }
    
    public function fromArray(array $data) : self
    {
        $this->data = array_replace($this->data, $data);

        $this->loadData();

        return $this;
    }

    public function loadData() : static
    {
        if (is_array($picea = $this->data['picea'] ?? false)) {
            if ($picea['context'] ?? false ) {
                $this->piceaContext = $picea['context'];
            }

            if ($picea['extensions'] ?? false ) {
                $this->piceaExtensions = $picea['extensions'];
            }

            if ($picea['asset'] ?? false ) {
                $this->piceaAssets = $picea['asset'];
            }

            if ($picea['view'] ?? false) {
                $this->views = $picea['view'];
            }
        }

        if (is_array($ulmus = $this->data['ulmus'] ?? false)) {
            if ($ulmus['entities'] ?? false) {
                $this->entities = $ulmus['entities'];
                $this->connectionAdapters = $ulmus['adapters'] ?? [];
            }
        }

        if (is_array($tell = $this->data['tell'] ?? false)) {
            if ($tell['json'] ?? false) {
                $this->tellJson = $tell['json'];
            }

            if ($tell['php'] ?? false) {
                $this->tellPhp = $tell['php'];
            }
        }

        if (is_array($this->data['routes'] ?? false)) {
            $this->routes = $this->data['routes'];
        }

        if (is_array($this->data['cronard'] ?? false)) {
            $this->cronard = $this->data['cronard'];
        }

        if (is_array($this->data['events'] ?? false)) {
            $this->events = $this->data['events'];
        }

        if (is_array($this->data['cli'] ?? false)) {
            $this->cli = $this->data['cli'];
        }

        if (is_array($this->data['taxus'] ?? false)) {
            $this->taxus = $this->data['taxus'];
        }

        return $this;
    }
}